rawset(_G, "meatboy", {})
for a = 1,4
	for b = 1,5
		for c = 1,2
			for d = 1,9
				freeslot("sfx_mfeet"+a, "sfx_mjump"+b, "sfx_mland"+c,"sfx_mimpc"+d)
			end
		end
	end
end

local meatsoundtrack = true
local meatsounds = true

sfxinfo[sfx_mfeet1].caption = "Footsteps"
sfxinfo[sfx_mfeet2].caption = "Footsteps"
sfxinfo[sfx_mfeet3].caption = "Footsteps"
sfxinfo[sfx_mfeet4].caption = "Footsteps"
sfxinfo[sfx_mjump1].caption = "Meaty Jump"
sfxinfo[sfx_mjump2].caption = "Meaty Jump"
sfxinfo[sfx_mjump3].caption = "Meaty Jump"
sfxinfo[sfx_mjump4].caption = "Meaty Jump"
sfxinfo[sfx_mjump5].caption = "Meaty Jump"
sfxinfo[sfx_mland1].caption = "Landing"
sfxinfo[sfx_mland2].caption = "Landing"
sfxinfo[sfx_mimpc1].caption = "Impact"
sfxinfo[sfx_mimpc2].caption = "Impact"
sfxinfo[sfx_mimpc3].caption = "Impact"
sfxinfo[sfx_mimpc4].caption = "Impact"
sfxinfo[sfx_mimpc5].caption = "Impact"
sfxinfo[sfx_mimpc6].caption = "Impact"
sfxinfo[sfx_mimpc7].caption = "Impact"
sfxinfo[sfx_mimpc8].caption = "Impact"
sfxinfo[sfx_mimpc9].caption = "Impact"

local function CngMus(player, music)
	COM_BufInsertText(player, "tunes "+music)
end

local cv_meatrail = CV_RegisterVar({"meatboy_trail", "On", CV_NETVAR, CV_OnOff})
local cv_meatparticles = CV_RegisterVar({"meatboy_lowparticles", "Off", CV_NETVAR, CV_OnOff})

COM_AddCommand("meatboy_soundtrack", function(player, arg)
	if arg == "1" or arg == "true" or arg == "yes" or arg == "on"
		CONS_Printf(player, "SMB Soundtrack enabled.")
		local name = mapheaderinfo[gamemap].lvlttl
		if name == "Greenflower"
			CngMus(player, "FOREST")
		elseif name == "Techno Hill"
			CngMus(player, "SALT")
		elseif name == "Deep Sea"
			CngMus(player, "FLOODD")
		elseif name == "Castle Eggman"
			CngMus(player, "HOSPIT")
		elseif name == "Arid Canyon"
			CngMus(player, "DARKFR")
		elseif name == "Red Volcano"
			CngMus(player, "HELL")
		elseif name == "Egg Rock"
			CngMus(player, "RAPTUR")
		end
		player.meattrack = true
	elseif arg == "0" or arg == "false" or arg == "no" or arg == "off"
		player.meattrack = false
		CONS_Printf(player, "SMB Soundtrack disabled.")
	else
		CONS_Printf(player, "Invalid option!")
		return
	end
end)

addHook("MapLoad", function(mapnum)
	for player in players.iterate
		if not (player.meattrack) return end
		if player.mo.valid
			local name = mapheaderinfo[gamemap].lvlttl
			if mapheaderinfo[gamemap].bonustype	 == 1 return end
			if name == "Greenflower"
				CngMus(player, "FOREST")
			elseif name == "Techno Hill"
				CngMus(player, "SALT")
			elseif name == "Deep Sea"
				CngMus(player, "FLOODD")
			elseif name == "Castle Eggman"
				CngMus(player, "HOSPIT")
			elseif name == "Arid Canyon"
				CngMus(player, "DARKFR")
			elseif name == "Red Volcano"
				CngMus(player, "HELL")
			elseif name == "Egg Rock"
				CngMus(player, "RAPTUR")
			end
		end
	end
end)

addHook("PlayerSpawn", function(player)
	player.mbangle = 0
	player.mbinit = 1
	player.mbhitfloor = 0
	player.mbimpact = 0
	player.mbeffect = false
end)

addHook("PlayerThink", function(player)
	if not player.mo.valid
		or player.mo.skin ~= "meatboy"
	return end
	
	player.lives = INFLIVES
	
	if not player.meattrack
		player.meattrack = false
	end
	
	if not P_IsObjectOnGround(player.mo)
		player.mbhitfloor = 1
	end
	
	if S_SoundPlaying(player.mo, sfx_jump)
	and not S_SoundPlaying(player.mo, sfx_mjump1)
	and not S_SoundPlaying(player.mo, sfx_mjump2)
	and not S_SoundPlaying(player.mo, sfx_mjump3)
	and not S_SoundPlaying(player.mo, sfx_mjump4)
	and not S_SoundPlaying(player.mo, sfx_mjump5)
		local ran = P_RandomRange(0,4)
		if ran == 0
			S_StartSound(player.mo, sfx_mjump1)
		elseif ran == 1
			S_StartSound(player.mo, sfx_mjump2)
		elseif ran == 2
			S_StartSound(player.mo, sfx_mjump3)
		elseif ran == 3
			S_StartSound(player.mo, sfx_mjump4)
		else
			S_StartSound(player.mo, sfx_mjump5)
		end		
	end
	
	if player.mo.state == S_PLAY_RUN and player.mo.frame == 1 and P_IsObjectOnGround(player.mo)
		local ran = P_RandomRange(0,3)
		if ran == 0
			S_StartSound(player.mo, sfx_mfeet1)
		elseif ran == 1
			S_StartSound(player.mo, sfx_mfeet2)
		elseif ran == 2
			S_StartSound(player.mo, sfx_mfeet3)
		else
			S_StartSound(player.mo, sfx_mfeet4)
		end
	end

	if P_PlayerInPain(player) and player.playerstate != PST_DEAD then
		P_DamageMobj(player.mo,nil,nil,1,DMG_INSTAKILL)
	end
	
	if P_IsObjectOnGround(player.mo) and player.mbhitfloor == 1
			local ran = P_RandomRange(0,1)
			if ran == 0
				S_StartSound(player.mo, sfx_mland1)
			elseif ran == 1
				S_StartSound(player.mo, sfx_mland2)
			end
		player.mbhitfloor = 0
		if (cv_meatrail.value) 
		and not (cv_meatparticles.value)
		and (player.playerstate == PST_LIVE)
			A_Create_Liquid(player.mo, 2, 10, player.mo.color, 10)
			A_Create_Liquid(player.mo, 2, 8, player.mo.color, 12)
			A_Create_Liquid(player.mo, 2, 6, player.mo.color, 14)
		end
	end
	
	if (player.mbeffect == true)
		player.mbeffect = false
		S_StartSound(player.mo, sfx_jump)
		if (player.mo.eflags & MFE_UNDERWATER)
			player.mo.momz = 6*FRACUNIT*P_MobjFlip(player.mo)
		else
			player.mo.momz = 12*FRACUNIT*P_MobjFlip(player.mo)
		end
		player.mo.momx = $ + $/2
		player.mo.momy = $ + $/2
		player.mo.flags = $1 & ~MF_NOCLIPTHING
	end

	if player.mo.eflags & MFE_UNDERWATER
		player.normalspeed = skins[player.mo.skin].normalspeed*2
	else
		player.normalspeed = skins[player.mo.skin].normalspeed
	end
	
	if P_IsObjectOnGround(player.mo)
		player.mbjump = nil
		player.mbimpact = 0
		if (cv_meatrail.value)
			local trail = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z-(player.mo.height*P_MobjFlip(player.mo)), MT_LIQUID)
			trail.color = player.mo.color
			trail.scale = player.mo.scale
			trail.state = S_LIQD_BIG_SPLAT
			trail.momz = -20*FRACUNIT*P_MobjFlip(player.mo)
			if (player.mo.eflags & MFE_VERTICALFLIP)
				trail.flags2 = $1^^MF2_OBJECTFLIP
			end
		end
	else
		if (player.cmd.buttons & BT_JUMP) and (player.mbjump == nil)
			player.mbjump = true
		end
	end
end)

local function meatsctdo(mobj)
	mobj.player.drawangle = mobj.angle+ANGLE_180
	if mobj.player.mbimpact == 0
		mobj.player.mbimpact = 1
			local ran = P_RandomRange(0,8)
			if ran == 0
				S_StartSound(mobj, sfx_mimpc1)
			elseif ran == 1
				S_StartSound(mobj, sfx_mimpc2)
			elseif ran == 2
				S_StartSound(mobj, sfx_mimpc3)
			elseif ran == 3
				S_StartSound(mobj, sfx_mimpc4)
			elseif ran == 4
				S_StartSound(mobj, sfx_mimpc5)
			elseif ran == 5
				S_StartSound(mobj, sfx_mimpc6)
			elseif ran == 6
				S_StartSound(mobj, sfx_mimpc7)
			elseif ran == 7
				S_StartSound(mobj, sfx_mimpc8)
			else
				S_StartSound(mobj, sfx_mimpc9)
		end
	end
	if (P_MobjFlip(mobj)*mobj.momz < -4*FRACUNIT)
		mobj.momz = -P_MobjFlip(mobj)*4*FRACUNIT
	end
	mobj.state = S_PLAY_FALL
	if mobj.eflags & MFE_UNDERWATER
		P_SetObjectMomZ(mobj, P_MobjFlip(mobj)*gravity/4, true)
	else
		P_SetObjectMomZ(mobj, P_MobjFlip(mobj)*gravity/2, true)
	end
	if not (mobj.player.cmd.buttons & BT_JUMP) and (mobj.player.mbjump == true)
		mobj.player.mbjump = false
	end
	if (mobj.player.cmd.buttons & BT_JUMP) and (mobj.player.mbjump == false)
		mobj.player.mbeffect = true
		if (mobj.eflags & MFE_UNDERWATER)
			mobj.momz = 6*FRACUNIT*P_MobjFlip(mobj)
		else
			mobj.momz = 12*FRACUNIT*P_MobjFlip(mobj)
		end
		P_InstaThrust(mobj, mobj.angle+ANGLE_180, 24*FRACUNIT)
		mobj.angle = $ + ANGLE_180
		mobj.drawangle = mobj.angle
		mobj.flags = $1|MF_NOCLIPTHING
		mobj.player.mbjump = true
		return
	else
		if (mobj.player.mbjump == true) return end
		if (mobj.player.speed > 2*FRACUNIT)
			P_InstaThrust(mobj, R_PointToAngle2(0, 0, mobj.momx, mobj.momy), 2*FRACUNIT)
		end
	end
end

addHook("MobjMoveCollide", function(mo, other)
	if (mo.valid) and (mo.player) and (mo.skin == "meatboy")
	and (other.valid) and (other.flags & MF_SPRING)
	and (other.z <= mo.z)
	and (mo.z <= other.z + other.height)
		if (cv_meatrail.value)
			A_Create_Liquid(mo, 2, 10, mo.color, 10)
			A_Create_Liquid(mo, 2, 8, mo.color, 12)
			A_Create_Liquid(mo, 2, 6, mo.color, 14)
		end
	end
end)

addHook("PlayerThink", function(player)
	if (player.mo.valid and player.mo.skin == "meatboy")
		player.powers[pw_underwater] = 696969
		player.powers[pw_spacetime] = 696969
		if (player.powers[pw_pushing])
		and not P_IsObjectOnGround(player.mo)
		and (player.powers[pw_carry] == CR_NONE)
		and not P_PlayerInPain(player)
			meatsctdo(player.mo)
		end
		if not (player.mo.targetposition) return end
		player.mo.flags2 = $1|MF2_DONTDRAW
		P_TeleportMove(player.mo, player.mo.x, player.mo.y, player.mo.targetposition)
	end
end)