//his rick roll is overpowered

//but we can enable/disable use for it
local cv_rickroll = CV_RegisterVar({"meatboy_rickroll", "On", CV_NETVAR, CV_OnOff})

freeslot("S_MEAT_DANCE", "SPR_RCRL", "MT_RICKROLL", "S_RICKROLL")
mobjinfo[MT_RICKROLL] = {
	spawnhealth = 1,
	spawnstate = S_RICKROLL,
	flags = MF_NOGRAVITY|MF_NOCLIPTHING
}
states[S_RICKROLL] = {SPR_RCRL, 0, -1, nil, 0, 0, S_RICKROLL}
states[S_MEAT_DANCE] = {SPR_PLAY, SPR2_MLEE|FF_ANIMATE, -1, nil, 61, 8, S_PLAY_STND}

addHook("MobjThinker", function(mobj)
	if (mobj.valid) and (mobj.health)
		P_SpawnGhostMobj(mobj)
		P_KillMobj(mobj)
	end
end, MT_RICKROLL)

addHook("ShouldDamage", function(target, inflictor, source)
	if (target.valid) and (target.player) and (target.player.dance) and (target.skin == "abomination")
		if (inflictor.valid) and (inflictor.flags & MF_MISSILE)
			local oldmomz = inflictor.momz
			P_SpawnMobj(target.x, target.y, target.z, MT_RICKROLL)
			P_InstaThrust(inflictor, R_PointToAngle2(0,0,inflictor.momx,inflictor.momz), -FixedHypot(inflictor.momx, inflictor.momy))
			inflictor.momz = -oldmomz
			return false
		elseif (inflictor.valid) and (inflictor.nodmg)
			return false
		end
	end
end)

addHook("PlayerThink", function(player)
  if (player.mo.skin ~= "abomination")
  or not (cv_rickroll.value)
    return
  end

  if not (player.dance)
    player.dance = false
  end

  if (player.cmd.buttons & BT_CUSTOM1)
  and (player.powers[pw_carry] == CR_NONE)
    player.dance = true
  end
  
  if (player.dance == true)
   COM_BufInsertText(player, "tunes rickro")
   if player.mo.state ~= S_MEAT_DANCE
    player.mo.state = S_MEAT_DANCE
   end
   player.pflags = $1|PF_FULLSTASIS
   if (player.cmd.buttons & BT_CUSTOM2)
	player.dance = false
	player.mo.state = S_PLAY_STND
	COM_BufInsertText(player, "tunes -default")
   end
	local enemy = P_LookForEnemies(player)
	if not (enemy) return end
	if (enemy.valid)
	and (enemy.flags & MF_ENEMY)
		P_KillMobj(enemy)
		local explosion = P_SpawnMobj(enemy.x, enemy.y, enemy.z, MT_EXPLODE)
		explosion.scale = enemy.scale/3
		explosion.state = S_TNTBARREL_EXPL1
		explosion.target = player.mo
		explosion.nodmg = true
   end
  end
end)

//mad lad with his broken sounds

freeslot("sfx_mland","sfx_mland2")

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "abomination")
		and player.mo.state == S_PLAY_FALL
			player.mo.state = S_PLAY_ROLL
		end
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "abomination"
		and player.cmd.buttons & BT_USE
		and not (player.pflags & PF_SPINNING)
		and player.speed >= 25*FRACUNIT
		and P_IsObjectOnGround(player.mo)
		player.mo.state = S_PLAY_ROLL
		player.pflags = $1|PF_SPINNING
			S_StartSound(player.mo, sfx_mland2)
	    end
		if (player.mo) and (player.mo.skin == "abomination")
		and (player.mo.state == S_PLAY_WALK)
		and P_IsObjectOnGround(player.mo)
			if (player.mo.frame == 3) or (player.mo.frame == 6)
				S_StartSound(player.mo, sfx_mland)
			end
		end
		if P_IsObjectOnGround(player.mo)
			player.mbjump = nil
		else
			if (player.cmd.buttons & BT_JUMP) and (player.mbjump == nil)
				player.mbjump = true
			end
		end
    end
end)

//the broken walljump intended for the joke character

local function meatsctdo(mobj, line)
	local ang = R_PointToAngle2(mobj.x, mobj.y, P_ClosestPointOnLine(mobj.x, mobj.y, line))+ANGLE_180
	mobj.momz = $ + (mobj.player.speed) / 10
	P_InstaThrust(mobj, ang+ANGLE_180, 50*FRACUNIT)
	if mobj.player.mbimpact == 0
		mobj.player.mbimpact = 1
		local ran = P_RandomRange(0,8)
		if ran == 0
			S_StartSound(mobj, sfx_mimpc1)
		elseif ran == 1
			S_StartSound(mobj, sfx_mimpc2)
		elseif ran == 2
			S_StartSound(mobj, sfx_mimpc3)
		elseif ran == 3
			S_StartSound(mobj, sfx_mimpc4)
		elseif ran == 4
			S_StartSound(mobj, sfx_mimpc5)
		elseif ran == 5
			S_StartSound(mobj, sfx_mimpc6)
		elseif ran == 6
			S_StartSound(mobj, sfx_mimpc7)
		elseif ran == 7
			S_StartSound(mobj, sfx_mimpc8)
		else
			S_StartSound(mobj, sfx_mimpc9)
		end
	end
	if (mobj.momz < -4*FRACUNIT)
		mobj.momz = -4*FRACUNIT
	end
	mobj.state = S_PLAY_FALL
	P_SetObjectMomZ(mobj, gravity*P_MobjFlip(mobj)/2, true)
	if not (mobj.player.cmd.buttons & BT_JUMP) and (mobj.player.mbjump == true)
		mobj.player.mbjump = false
	end
	mobj.player.drawangle = ang
	if (mobj.player.cmd.buttons & BT_JUMP) and (mobj.player.mbjump == false)
		S_StartSound(mobj, sfx_jump)
		mobj.momz = 12*FRACUNIT*P_MobjFlip(mobj)
		P_InstaThrust(mobj, ang, 24*FRACUNIT)
		mobj.angle = ang
		mobj.player.mbjump = true
	end
end

local function meatsctCheck(mobj, line)
	if not (mobj.player and mobj.player.valid) or (mobj.skin ~= "abomination") or P_IsObjectOnGround(mobj) then
		return
	end
	
    local cursec = line.frontsector
    if mobj.subsector.sector == cursec then cursec = line.backsector end

    if not cursec then
		meatsctdo(mobj, line)
        return false
    end
	
    local fheight = cursec.floorheight
    local cheight = cursec.ceilingheight

    if cursec.f_slope then
        fheight = P_GetZAt(cursec.f_slope, mobj.x + mobj.momx, mobj.y + mobj.momy)
    end
    if cursec.c_slope then
        cheight = P_GetZAt(cursec.c_slope, mobj.x + mobj.momx, mobj.y + mobj.momy)
    end

    mobj.curline = line
	
	if (mobj.z + mobj.height/2 < fheight or mobj.z + mobj.height/2 > cheight) then
		meatsctdo(mobj, line)
		return true
	else
		for rov in cursec.ffloors() do
			if rov.flags & FF_SOLID then
				if (mobj.z + mobj.height/2 > rov.bottomheight and mobj.z + mobj.height/2 < rov.topheight) then
					meatsctdo(mobj, line)
					return true
				end
			end
        end
    end 
end

addHook("MobjLineCollide", function(mobj, line)
	meatsctCheck(mobj, line)
end, MT_PLAYER)

hud.add(function(v, player, cam)
	if player.mo and player.mo.skin ~= "abomination" return end
	v.drawString(34, 170, "Never gonna give you up,", V_MONOSPACE|V_YELLOWMAP|V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "small-thin")
	v.drawString(34, 176, "never gonna let you down,", V_MONOSPACE|V_YELLOWMAP|V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "small-thin")
	v.drawString(34, 182, "never gonna run around and desert you.", V_MONOSPACE|V_YELLOWMAP|V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "small-thin")
end, "game")